searchNodes=[{"ref":"HTMLAssertion.html","title":"HTMLAssertion","type":"module","doc":"HTMLAssertion adds assertions for testing rendered HTML using CSS selectors. Usage in Phoenix Controller and Integration Test Import the HTML assertion functions in YourAppWeb.ConnCase. Remember to replace all instances of YourApp with your app module name. defmodule YourAppWeb.ConnCase do . . . using do quote do # Import conveniences for testing with connections use Phoenix.ConnTest alias YourAppWeb.Router.Helpers, as: Routes use HTMLAssertion # Imports assert_select, refute_select # The default endpoint for testing @endpoint YourAppWeb.Endpoint end end . . . end Assuming the html_response(conn, 200) returns: &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;title&gt;PAGE TITLE&lt;/title&gt; &lt;/head&gt; &lt;body&gt; &lt;a href=&quot;/signup&quot;&gt;Sign up&lt;/a&gt; &lt;a href=&quot;/help&quot;&gt;Help&lt;/a&gt; &lt;/body&gt; &lt;/html&gt; An example controller test: defmodule YourAppWeb.PageControllerTest do use YourAppWeb.ConnCase, async: true test &quot;should get index&quot;, %{conn: conn} do conn = conn |&gt; get(Routes.page_path(conn, :index)) html_response(conn, 200) # Page title is &quot;PAGE TITLE&quot; |&gt; assert_select(&quot;title&quot;, &quot;PAGE TITLE&quot;) # Page title is &quot;PAGE TITLE&quot; and there is only one title element |&gt; assert_select(&quot;title&quot;, count: 1, text: &quot;PAGE TITLE&quot;) # Page title matches &quot;PAGE&quot; and there is only one title element |&gt; assert_select(&quot;title&quot;, count: 1, match: &quot;PAGE&quot;) # Page has one link with href value &quot;/signup&quot; |&gt; assert_select(&quot;a[href=&#39;/signup&#39;]&quot;, count: 1) # Page has at least one link |&gt; assert_select(&quot;a&quot;, min: 1) # Page has at most two links |&gt; assert_select(&quot;a&quot;, max: 2) # Page contains no forms |&gt; refute_select(&quot;form&quot;) end end"},{"ref":"HTMLAssertion.html#assert_select/2","title":"HTMLAssertion.assert_select/2","type":"function","doc":"Asserts an attributes in HTML element assert attributes :text – asserts a text element in HTML :match - asserts containing value in html iex&gt; html = ~S{&lt;div class=&quot;foo bar&quot;&gt;&lt;/div&gt;&lt;div class=&quot;zoo bar&quot;&gt;&lt;/div&gt;} ...&gt; assert_select(html, &quot;.zoo&quot;, class: &quot;bar zoo&quot;) ~S{&lt;div class=&quot;foo bar&quot;&gt;&lt;/div&gt;&lt;div class=&quot;zoo bar&quot;&gt;&lt;/div&gt;} # check if `id` not exsists iex&gt; assert_select(~S{&lt;div&gt;text&lt;/div&gt;}, id: nil) &quot;&lt;div&gt;text&lt;/div&gt;&quot; Examples check :text Asserts a text element in HTML iex&gt; html = ~S{&lt;h1 class=&quot;title&quot;&gt;Header&lt;/h1&gt;} ...&gt; assert_select(html, text: &quot;Header&quot;) ~S{&lt;h1 class=&quot;title&quot;&gt;Header&lt;/h1&gt;} iex&gt; html = ~S{&lt;div class=&quot;container&quot;&gt; &lt;h1 class=&quot;title&quot;&gt;Header&lt;/h1&gt; &lt;/div&gt;} ...&gt; assert_select(html, &quot;.title&quot;, text: &quot;Header&quot;) ~S{&lt;div class=&quot;container&quot;&gt; &lt;h1 class=&quot;title&quot;&gt;Header&lt;/h1&gt; &lt;/div&gt;} iex&gt; html = ~S{&lt;h1 class=&quot;title&quot;&gt;Header&lt;/h1&gt;} ...&gt; try do ...&gt; assert_select(html, text: &quot;HEADER&quot;) ...&gt; rescue ...&gt; e in ExUnit.AssertionError -&gt; e ...&gt; end %ExUnit.AssertionError{ left: &quot;HEADER&quot;, right: &quot;Header&quot;, message: &quot;Comparison `text` attribute failed.\\n\\n\\t&lt;h1 class=\\&quot;title\\&quot;&gt;Header&lt;/h1&gt;.\\n&quot; } iex&gt; html = ~S{&lt;div class=&quot;foo&quot;&gt;Some &amp;amp; text&lt;/div&gt;} ...&gt; assert_select(html, text: &quot;Some &amp; text&quot;) ~S{&lt;div class=&quot;foo&quot;&gt;Some &amp;amp; text&lt;/div&gt;} Selector assert_select(html, &quot;css selector&quot;) iex&gt; html = ~S{&lt;p&gt;&lt;div class=&quot;foo&quot;&gt;&lt;h1&gt;Header&lt;/h1&gt;&lt;/div&gt;&lt;/p&gt;} ...&gt; assert_select(html, &quot;p .foo h1&quot;) ~S{&lt;p&gt;&lt;div class=&quot;foo&quot;&gt;&lt;h1&gt;Header&lt;/h1&gt;&lt;/div&gt;&lt;/p&gt;} iex&gt; html = ~S{&lt;p&gt;&lt;div class=&quot;foo&quot;&gt;&lt;h1&gt;Header&lt;/h1&gt;&lt;/div&gt;&lt;/p&gt;} ...&gt; assert_select(html, &quot;h1&quot;) ~S{&lt;p&gt;&lt;div class=&quot;foo&quot;&gt;&lt;h1&gt;Header&lt;/h1&gt;&lt;/div&gt;&lt;/p&gt;} Match elements in HTML assert_select(html, ~r{&lt;p&gt;Hello&lt;/p&gt;}) assert_select(html, match: ~r{&lt;p&gt;Hello&lt;/p&gt;}) assert_select(html, match: &quot;&lt;p&gt;Hello&lt;/p&gt;&quot;) \\# Asserts a text element in HTML Examples iex&gt; html = ~S{&lt;div class=&quot;container&quot;&gt; &lt;h1 class=&quot;title&quot;&gt;Hello World&lt;/h1&gt; &lt;/div&gt;} ...&gt; assert_select(html, &quot;h1&quot;, &quot;Hello World&quot;) == html true iex&gt; html = ~S{&lt;div class=&quot;container&quot;&gt; &lt;h1 class=&quot;title&quot;&gt;Hello World&lt;/h1&gt; &lt;/div&gt;} ...&gt; assert_select(html, &quot;.title&quot;, ~r{World}) ~S{&lt;div class=&quot;container&quot;&gt; &lt;h1 class=&quot;title&quot;&gt;Hello World&lt;/h1&gt; &lt;/div&gt;} assert elements in selector assert_select(html, &quot;.container table&quot;, ~r{&lt;p&gt;Hello&lt;/p&gt;})"},{"ref":"HTMLAssertion.html#assert_select/3","title":"HTMLAssertion.assert_select/3","type":"function","doc":""},{"ref":"HTMLAssertion.html#assert_select/4","title":"HTMLAssertion.assert_select/4","type":"function","doc":""},{"ref":"HTMLAssertion.html#refute_select/2","title":"HTMLAssertion.refute_select/2","type":"function","doc":""},{"ref":"HTMLAssertion.html#refute_select/3","title":"HTMLAssertion.refute_select/3","type":"function","doc":""},{"ref":"HTMLAssertion.html#refute_select/4","title":"HTMLAssertion.refute_select/4","type":"function","doc":""},{"ref":"HTMLAssertion.html#t:attribute_name/0","title":"HTMLAssertion.attribute_name/0","type":"type","doc":"HTML element attribute name"},{"ref":"HTMLAssertion.html#t:attributes/0","title":"HTMLAssertion.attributes/0","type":"type","doc":"HTML element attributes"},{"ref":"HTMLAssertion.html#t:css_selector/0","title":"HTMLAssertion.css_selector/0","type":"type","doc":"CSS selector Supported selectors PatternDescription *any element Ean element of type E E[foo]an E element with a &quot;foo&quot; attribute E[foo=&quot;bar&quot;]an E element whose &quot;foo&quot; attribute value is exactly equal to &quot;bar&quot; E[foo~=&quot;bar&quot;]an E element whose &quot;foo&quot; attribute value is a list of whitespace-separated values, one of which is exactly equal to &quot;bar&quot; E[foo^=&quot;bar&quot;]an E element whose &quot;foo&quot; attribute value begins exactly with the string &quot;bar&quot; E[foo$=&quot;bar&quot;]an E element whose &quot;foo&quot; attribute value ends exactly with the string &quot;bar&quot; E[foo*=&quot;bar&quot;]an E element whose &quot;foo&quot; attribute value contains the substring &quot;bar&quot; E[foo|=&quot;en&quot;]an E element whose &quot;foo&quot; attribute has a hyphen-separated list of values beginning (from the left) with &quot;en&quot; E:nth-child(n)an E element, the n-th child of its parent E:first-childan E element, first child of its parent E:last-childan E element, last child of its parent E:nth-of-type(n)an E element, the n-th child of its type among its siblings E:first-of-typean E element, first child of its type among its siblings E:last-of-typean E element, last child of its type among its siblings E.warningan E element whose class is &quot;warning&quot; E#myidan E element with ID equal to &quot;myid&quot; E:not(s)an E element that does not match simple selector s E Fan F element descendant of an E element E &gt; Fan F element child of an E element E + Fan F element immediately preceded by an E element E ~ Fan F element preceded by an E element"},{"ref":"HTMLAssertion.html#t:html/0","title":"HTMLAssertion.html/0","type":"type","doc":"HTML response"},{"ref":"HTMLAssertion.html#t:value/0","title":"HTMLAssertion.value/0","type":"type","doc":"Checking value if nil should not exist"},{"ref":"HTMLAssertion.DSL.html","title":"HTMLAssertion.DSL","type":"module","doc":"Add additional syntax to passing current context inside block Example: pass context assert_select html, &quot;.container&quot; do assert_select &quot;form&quot;, action: &quot;/users&quot; do refute_select &quot;.flash_message&quot; assert_select &quot;.control_group&quot; do assert_select &quot;label&quot;, class: &quot;title&quot;, text: ~r{Full name} assert_select &quot;input&quot;, class: &quot;control&quot;, type: &quot;text&quot; end assert_select(&quot;a&quot;, text: &quot;Submit&quot;, class: &quot;button&quot;) end assert_select &quot;.user_list&quot; do assert_select &quot;li&quot; end end Example 2: print current context for debug assert_select(html, &quot;.selector&quot;) do IO.inspect(assert_select, label: &quot;current context html&quot;) end"},{"ref":"HTMLAssertion.DSL.html#assert_select/4","title":"HTMLAssertion.DSL.assert_select/4","type":"macro","doc":""},{"ref":"HTMLAssertion.DSL.html#refute_select/4","title":"HTMLAssertion.DSL.refute_select/4","type":"macro","doc":""},{"ref":"readme.html","title":"HtmlAssertion","type":"extras","doc":"HtmlAssertion HTMLAssertion adds assertions for testing rendered HTML using CSS selectors. It is very useful in Phoenix controller and integration tests."},{"ref":"readme.html#installation","title":"HtmlAssertion - Installation","type":"extras","doc":"The package can be installed by adding html_assertion to your list of dependencies in mix.exs: def deps do [ {:html_assertion, &quot;~&gt; 0.1.3&quot;, only: :test} ] end Usage in Phoenix Controller and Integration Test Import the HTML assertion functions in YourAppWeb.ConnCase. Remember to replace all instances of YourApp with your app module name. defmodule YourAppWeb.ConnCase do . . . using do quote do # Import conveniences for testing with connections use Phoenix.ConnTest alias YourAppWeb.Router.Helpers, as: Routes use HTMLAssertion # The default endpoint for testing @endpoint YourAppWeb.Endpoint end end . . . end Assuming the html_response(conn, 200) returns: &lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;title&gt;PAGE TITLE&lt;/title&gt; &lt;/head&gt; &lt;body&gt; &lt;a href=&quot;/signup&quot;&gt;Sign up&lt;/a&gt; &lt;a href=&quot;/help&quot;&gt;Help&lt;/a&gt; &lt;/body&gt; &lt;/html&gt; An example controller test: defmodule YourAppWeb.PageControllerTest do use YourAppWeb.ConnCase, async: true test &quot;should get index&quot;, %{conn: conn} do conn = conn |&gt; get(Routes.page_path(conn, :index)) html_response(conn, 200) # Page title is &quot;PAGE TITLE&quot; |&gt; assert_select(&quot;title&quot;, &quot;PAGE TITLE&quot;) # Page title is &quot;PAGE TITLE&quot; and there is only one title element |&gt; assert_select(&quot;title&quot;, count: 1, text: &quot;PAGE TITLE&quot;) # Page title matches &quot;PAGE&quot; and there is only one title element |&gt; assert_select(&quot;title&quot;, count: 1, match: &quot;PAGE&quot;) # Page has one link with href value &quot;/signup&quot; |&gt; assert_select(&quot;a[href=&#39;/signup&#39;]&quot;, count: 1) # Page has at least one link |&gt; assert_select(&quot;a&quot;, min: 1) # Page has at most two links |&gt; assert_select(&quot;a&quot;, max: 2) # Page contains no forms |&gt; refute_select(&quot;form&quot;) end end Read the docs at https://hexdocs.pm/html_assertion."},{"ref":"changelog.html","title":"CHANGELOG","type":"extras","doc":""},{"ref":"changelog.html#v0-1-0","title":"CHANGELOG - v0.1.0","type":"extras","doc":"Added Add assert_select Add refute_select"}]